//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "FileWin.h"
#include "FileMan.h"
#include "Global.h"
#include "pgpmail.h"
#include "mixmaster.h"
//---------------------------------------------------------------------------
#pragma link "NoteWin"
#pragma link "explbtn"
#pragma resource "*.dfm"
TTextFileWin *TextFileWin;
//---------------------------------------------------------------------------
void __fastcall EditTextFile(AnsiString &FileName, TForm *Owner)
{
   AnsiString s;
   if (FileName==MixDir()+CRingTxt && HasPgp())
   {  // special handling of pubring.asc
      TStringList *keys = new TStringList();
      keys->LoadFromFile(FileName);
      keys->SetText(PgpArmorBlockToArmorKeys(keys->Text.c_str()));
      EditFileText(keys,FileName);
      delete keys;
      return;
   }
   if (FileName==MixDir()+MTyp2Txt && HasPgp())
   {  // special handling of type2.list
      TStringList *lines = new TStringList();
      lines->LoadFromFile(FileName);
      if (lines->Count)
      {
         lines->Sorted = true;
         bool ok=false;
         for (int i=0; i<lines->Count; i++)
            if (lines->Strings[i].SubString(1,1)!="#")
               ok = true;
         lines->Sorted = false;
         if (ok) while (lines->Strings[0].SubString(1,1)=="#")
         {
            s = lines->Strings[0];
            lines->Delete(0);
            lines->Add(s);
         }
      }
      EditFileText(lines,FileName);
      delete lines;
      return;
   }
   TextFileWin = new TTextFileWin(FileName,Owner);
}
//---------------------------------------------------------------------------
bool __fastcall TTextFileWin::Save()
{
   AnsiString fn=filename,md=MixDir();
   TStringList *lines = new TStringList();
   lines->Text = Editor->Lines->Text;
   // special handling all stats docs
   bool stats =
      fn==md+CRingTxt || fn==md+CListTxt || fn==md+CTyp1Txt ||
      fn==md+MRingTxt || fn==md+MListTxt || fn==md+MTyp2Txt;
   // special handling of pubring.asc stats doc
   if (fn==md+CRingTxt && HasPgp()) // needsPgp...very important
      lines->SetText(PgpArmorKeysToArmorBlock(lines->Text.c_str()));
   // save the document
   if (stats)
      SaveToFileBak(lines,fn,STATSBAKCOPIES);
   else
      lines->SaveToFile(fn);
   // done
   Editor->Modified = false;
   delete lines;
   return true;
}
//---------------------------------------------------------------------------
void __fastcall EditFileText(TStrings *Text, AnsiString &FileName, TForm *Owner)
{
   TextFileWin = new TTextFileWin(Text,FileName,Owner);
}
//---------------------------------------------------------------------------
__fastcall TTextFileWin::TTextFileWin(TComponent* Owner)
  : TTextWin(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TTextFileWin::TTextFileWin(AnsiString &Filename, TComponent* Owner)
  : TTextWin(Owner)
{
   Editor->WordWrap = false;
   EditWordWrapItem->Checked = false;
   filename = Filename;
   if (FileExists(filename))
   {
      TStringList *txt = new TStringList();
      txt->LoadFromFile(filename);
      SetText("...\\"+ExtractFileName(Filename),txt);
      delete txt;
   }
}
//---------------------------------------------------------------------------
__fastcall TTextFileWin::TTextFileWin(TStrings *Txt, AnsiString &Filename, TComponent* Owner)
  : TTextWin(Owner)
{
   Editor->WordWrap = false;
   EditWordWrapItem->Checked = false;
   filename = Filename;
   SetText(ExtractFileName(Filename),Txt);
}
//---------------------------------------------------------------------------
bool __fastcall TTextFileWin::SaveAs()
{// not needed but placed for safety
   return false;
}
//---------------------------------------------------------------------------
void __fastcall TTextFileWin::SetText(AnsiString &Name, TStrings *Text)
{
//   IndexStr = Name;
//   DataKey = UserNotes+PS+Name;
   Caption = Name;
   Editor->OnSelectionChange = NULL;
   Editor->Lines->Text = Text->Text;
   Editor->Modified = false;
   Editor->SelStart = 0;
   Editor->OnSelectionChange = EditorSelectionChange;
   ShowCurXY(true);
}
//---------------------------------------------------------------------------
bool __fastcall TTextFileWin::CheckSave()
{
   bool ok = true;
   if (Editor->Modified)
   {
      int reply = MsgBoxHwnd(Handle,
            ExtractFileName(filename).UpperCase()+" has been modified. Changes will be lost!\n\nSave it now?",
               "Save File",MB_YESNOCANCEL);
      switch(reply)
      {
         case IDCANCEL: ok = false; break;
         case IDYES: Save(); break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
