//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "PgpRecips.h"
#include "PgpFiles.h"
#include "Version.h"
#include "Global.h"
#include "mixmaster.h"
#include "pgp.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPgpRecipForm *PgpRecipForm;
//---------------------------------------------------------------------------
bool __fastcall PGPgetEncryptList(TStrings *Recips, bool AllowConventional)
{
   AnsiString keystr;
   bool ok=false,opendlg=false;
   TPgpRecipForm *pf = new TPgpRecipForm(ActMainForm);
   TStrings *List = pf->ListBox2->Items;
   // transfer recips to list, skipping dialog if all recips have pubkeys
   for (int i=0; i<Recips->Count; i++)
   {
      keystr = pf->GetKeyStr(Recips->Strings[i]);
      if (GetParam(1,keystr,"\255").Pos("0x")!=1) opendlg=true;
      List->Add(keystr);
   }
   pf->Conventional->Enabled = AllowConventional;

   if (opendlg)
       pf->ShowModal();
   if (pf->ModalResult==mrOk || !opendlg)
   {
      Recips->Clear();
      if (pf->Conventional->Checked) Recips->Add(UseConventional);
      else
      {
         // transfer keylist back to recips
         for (int i=0; i<List->Count; i++)
         {
            if (GetParam(1,List->Strings[i],"\255").Pos("0x")!=1) continue;
            Recips->Add(List->Strings[i]);
         }
      }
      ok = true;
   }
   delete pf;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TPgpRecipForm::TPgpRecipForm(TComponent* Owner)
  : TForm(Owner)
{
   AnsiString remringasc=MixDir()+"pubring.asc";
   CenterDialog(this,(TForm*)Owner);
   RemKeys->Enabled = false;
   keys = new TStringList();
   To = new TStringList();
   remdb = NULL;
   pgpdb = new TPgpDb(PgpDir()+"pubring.pgp",PgpDir()+"secring.pgp");
   if (FileExists(remringasc))
   {
      remdb = new TPgpDb(remringasc,"");
      RemKeys->Enabled = true;
   }
   LoadPublics(MyKeys->Checked ? pgpdb : remdb);
}
//---------------------------------------------------------------------------
AnsiString __fastcall  TPgpRecipForm::KeyStr(TPgpKey *key, int id)
{
   return key->UserIds->Strings[id]+"\255"+"0x"+key->IdText8+"\255"+
     (key->Algorithm==1?"RSA":"ERR")+AnsiString(" ")+
      AnsiString(key->KeyBits)+"\255"+key->Keyring;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPgpRecipForm::GetKeyStr(AnsiString &id)
{
   int uid;
   AnsiString keystr;
   TPgpDb *db=pgpdb; TPgpKey *key;

   key = db->FirstKey();
   while (keystr.IsEmpty())
   {
      while (key)
      {
         // if there is a IdText8 in the string
         if (id.Pos("0x")==1)
         {
            if (id=="0x"+key->IdText8) keystr = KeyStr(key,0);
            break;
         }
         // is the recip id within any userids of this key
         uid = -1;
         for (int i=0; i<key->UserIds->Count; i++)
         {
            if (key->UserIds->Strings[i].Pos(id)>0)
            {
               uid = i;
               break;
            }
         }
//sm(key->UserIds->Text);
         if (uid>=0)
         {
            keystr = KeyStr(key,uid);
            break;
         }
         // test next key on ring
         key = key->Next;
      }
      if (keystr.IsEmpty() && db==pgpdb && remdb)
      {
         db = remdb;
         key = db->FirstKey();
//sm(key->UserIds->Text);
      }
      else break;
   }
   if (keystr.IsEmpty()) keystr = id;
   return keystr;
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::LoadPublics(TPgpDb *db)
{
   ListBox1->Clear();
   Application->ProcessMessages();
   Sleep(100);
   bool locked = LockWindowUpdate(Handle);
   ListBox1->Sorted = SortBox->Checked;
   TStringList *ids = new TStringList();
   TPgpKey *key = db->FirstKey();
   while (key)
   {
      ids->Clear();
      for (int i=0; i<key->UserIds->Count; i++)
         ids->Add(KeyStr(key,i));
      ListBox1->Items->AddStrings(ids);
      key = key->Next;
   }
   if (locked) LockWindowUpdate(0);
   delete ids;
}
//---------------------------------------------------------------------------
__fastcall TPgpRecipForm::~TPgpRecipForm()
{
   delete remdb;
   delete pgpdb;
   delete keys;
   delete To;
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::WhichKeysClick(TObject *Sender)
{
   LoadPublics(MyKeys->Checked ? pgpdb : remdb);
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::ListBoxDrawItem(TWinControl *Control, int Index,
  TRect &Rect, TOwnerDrawState State)
{
   TListBox *ListBox = dynamic_cast<TListBox*>(Control);
   TRect r = Rect;
   TCanvas *canvas = ListBox->Canvas;
   canvas->FillRect(r);
   AnsiString keystr = ListBox->Items->Strings[Index];
   int rr = r.Right;
   // username/address
   r.Left += 6; r.Right = r.Left + 302;
   // recip with no key
   if (ListBox==ListBox2 && GetParam(1,keystr,"\255").SubString(1,2)!="0x")
   {
      TFontStyles style;
      canvas->Font->Style = style << fsStrikeOut;
      canvas->TextRect(r,r.Left,r.Top,keystr+" ");
      return;
   }
   // recip /w key OR a key
   AnsiString name=GetParam(0,keystr,"\255");
   canvas->TextRect(r,r.Left,r.Top,name);
   // if text is too long for rect
   if (canvas->TextWidth(name)>r.Right-r.Left) canvas->TextOut(r.Right-7,r.Top,"...");
   // key id
   int ml = canvas->TextWidth("D")-1;
   AnsiString keyid = GetParam(1,keystr,"\255");
   r.Left = r.Right+20; r.Right = r.Left+ml;
   for (int i=1; i<=keyid.Length(); i++)
   {
      canvas->TextRect(r,r.Left,r.Top,keyid.SubString(i,1));
      r.Left += ml; r.Right = r.Left + ml;
   }
   // algo + size
   r.Left = r.Right + 12; r.Right = rr - 5;
   canvas->TextRect(r,r.Left,r.Top,GetParam(2,keystr,"\255"));
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::ListBox1DblClick(TObject *Sender)
{
   if (ListBox1->ItemIndex>=0)
   {
      ListBox2->Items->Add(ListBox1->Items->Strings[ListBox1->ItemIndex]);
//      ListBox1->Items->Delete(ListBox1->ItemIndex);
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::ListBox2DblClick(TObject *Sender)
{
   if (ListBox2->ItemIndex>=0 && MsgBoxHwnd(Handle,"Remove this recipient?",
      "Confirm",MB_OKCANCEL)==IDOK)
   {
      ListBox1->Items->Add(ListBox2->Items->Strings[ListBox2->ItemIndex]);
      ListBox2->Items->Delete(ListBox2->ItemIndex);
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::FormShow(TObject *Sender)
{
//   LoadPublics(MyKeys->Checked ? pgpdb : remdb);
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::ConventionalClick(TObject *Sender)
{
   if (Conventional->Checked)
   {
      To->Text = ListBox2->Items->Text;
      ListBox1->Clear(); ListBox1->Color = clBtnFace; ListBox1->Enabled = false;
      ListBox2->Clear(); ListBox2->Color = clBtnFace; ListBox2->Enabled = false;
      if (remdb) RemKeys->Enabled = false;
      SortBox->Enabled = false;
      MyKeys->Enabled = false;
   }
   else
   {
      ListBox1->Color = clWindow; ListBox1->Enabled = true;
      ListBox2->Color = clWindow; ListBox2->Enabled = true;
      LoadPublics(MyKeys->Checked ? pgpdb : remdb);
      if (remdb) RemKeys->Enabled = true;
      ListBox2->Items->Text = To->Text;
      SortBox->Enabled = true;
      MyKeys->Enabled = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk && !ListBox2->Items->Count && !Conventional->Checked)
   {
      MsgBoxHwnd(Handle,
         AnsiString("You must either select at least one valid recipient\n")+
         AnsiString("or choose the Conventional Encryption option"),
        "No Recipients Selected",
         MB_OK);
      CanClose = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::ListBox2DragOver(TObject *Sender,
  TObject *Source, int X, int Y, TDragState State, bool &Accept)
{
   TListBox *src = dynamic_cast<TListBox*>(Source);
   if (src) Accept=true;
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::ListBox2DragDrop(TObject *Sender,
  TObject *Source, int X, int Y)
{
    TListBox *src = dynamic_cast<TListBox*>(Source);
    if (src)
    {
       ListBox2->Items->Add(src->Items->Strings[src->ItemIndex]);
       src->Items->Delete(src->ItemIndex);
    }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::ListBox1DragDrop(TObject *Sender,
  TObject *Source, int X, int Y)
{
    TListBox *src = dynamic_cast<TListBox*>(Source);
    if (src)
    {
       ListBox1->Items->Add(src->Items->Strings[src->ItemIndex]);
       src->Items->Delete(src->ItemIndex);
    }
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::ListBox1DragOver(TObject *Sender,
  TObject *Source, int X, int Y, TDragState State, bool &Accept)
{
   TListBox *src = dynamic_cast<TListBox*>(Source);
   if (src) Accept = true;
}
//---------------------------------------------------------------------------
void __fastcall TPgpRecipForm::SortBoxClick(TObject *Sender)
{
   LoadPublics(MyKeys->Checked ? pgpdb : remdb);
}
//---------------------------------------------------------------------------
