#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "QueueDlg.h"
#include "Global.h"
#include "SmtpDlg.h"
#include "FileMan.h"
#include "HeadMan.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TQueueForm *QueueForm;
//extern mrResult;
//---------------------------------------------------------------------------
bool __fastcall QueueMessage(TRichEdit *Editor, int WordWrap, bool UseDialog)
{
   bool locked,ww=Editor->WordWrap,ok=true;
   locked = LockWindowUpdate(((TForm*)Editor->Owner)->Handle);
   if (ww) Editor->WordWrap = false;
   // remove any previous error messages from top of message
   while (Editor->Lines->Count && Editor->Lines->Strings[0].SubString(1,1)=="#")
      Editor->Lines->Delete(0);
   // add wordwrap header
   Editor->Lines->Insert(0,WordWrapHeader+AnsiString(WordWrap));
   // queue
   QueueForm = new TQueueForm(Editor->Lines,Application->MainForm);
   if (UseDialog)
      ok = QueueForm->Execute();
   else
      QueueForm->QueueMessage();
   delete QueueForm;
   // remove wordwrap header and rewrap
   Editor->Lines->Delete(0);
   if (ww) Editor->WordWrap = true;
   if (locked) LockWindowUpdate(0);

   return ok;
}
//---------------------------------------------------------------------------
__fastcall TQueueForm::TQueueForm(TComponent* Owner)
	: TForm(Owner)
{
   // Center in Main Window
   TForm *Main = Application->MainForm;
   Top = Main->Top+((Main->Height-Height)/2);
   Left = Main->Left+((Main->Width-Width)/2);
   // initialize
   Message = NULL;
}
//---------------------------------------------------------------------------
__fastcall TQueueForm::TQueueForm(TStrings* message, TComponent* Owner)
	: TForm(Owner)
{
   // Center in Main Window
   TForm *Main = Application->MainForm;
   Top = Main->Top+((Main->Height-Height)/2);
   Left = Main->Left+((Main->Width-Width)/2);
   // initialize
   Message = message;
}
//---------------------------------------------------------------------------
void __fastcall TQueueForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrCancel && Message)
   {
      MsgBox("      Operation cancelled!      ","Cancel",MB_OK);
      PutAppData(MailQueue+PS+HeadMan->IndexString(Message),NULL);
   }
}
//---------------------------------------------------------------------------
void __fastcall TQueueForm::FormShow(TObject *Sender)
{
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TQueueForm::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   Sleep(100); Display->Caption = "Queueing message...";
   Application->ProcessMessages();
   if (Message && ModalResult==mrNone)
      QueueMessage();
   waiting = true; Timer2->Enabled = true;
   while (waiting) Application->ProcessMessages();
   if (ModalResult==mrNone) ModalResult=mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TQueueForm::Timer2Timer(TObject *Sender)
{
   waiting = false;
}
//---------------------------------------------------------------------------
bool __fastcall TQueueForm::Execute()
{
   QueueForm->ShowModal();
   return QueueForm->ModalResult==mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TQueueForm::QueueMessage()
{
   if (Message)
      PutAppData(MailQueue+PS+HeadMan->IndexString(Message),Message);
}
//---------------------------------------------------------------------------
